﻿using System;
using System.IO;

namespace TftpServer
{
    internal class TftpTransferSession
    {
        public DateTime LastActivity { get; set; }

        public string FilePath { get; }

        public long FileLength { get; }

        public byte[] BlockBuffer { get; }

        public int BlockCount { get; }

        public TftpTransferSession(string filePath, int blockSize)
        {
            FilePath = filePath;
            FileLength = new FileInfo(filePath).Length;
            BlockBuffer = new byte[blockSize];

            BlockCount = (int)Math.Ceiling(FileLength / (double)blockSize);

            LastActivity = DateTime.Now;
        }

        public int Read(int blockNumber, BlockReader reader)
        {
            LastActivity = DateTime.Now;
            return reader.ReadBlock(blockNumber, BlockBuffer);
        }
    }
}