﻿using System.IO;
using System.Text;

namespace TftpServer.Utils
{
    internal static class ExtensionMethods
    {
        public static void WriteNullTerminatedString(this MemoryStream stream, string str)
        {
            var buffer = Encoding.ASCII.GetBytes(str);
            stream.Write(buffer, 0, buffer.Length);
            stream.WriteByte(0);
        }

        public static string ReadNullTerminatedString(this MemoryStream stream)
        {
            var buffer = stream.GetBuffer();
            var len = ScanNullTerminated(buffer, stream.Position);
            var ret = Encoding.ASCII.GetString(buffer, (int)stream.Position, len);
            stream.Position += len + 1;
            return ret;
        }

        public static int ScanNullTerminated(this byte[] bytes, long offset)
        {
            return ScanTo(bytes, offset, 0);
        }

        public static int ScanTo(this byte[] bytes, long offset, byte match)
        {
            for (var i = offset; i < bytes.Length; i++)
            {
                if (bytes[i] == match)
                {
                    return (int)(i - offset);
                }
            }

            return -1;
        }
    }
}